library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity shiftreg1536 is
	port(	shiftin: in STD_LOGIC_VECTOR(7 downto 0);
			clk: in STD_LOGIC;
			rst: in STD_LOGIC;
			parallel_out: out STD_LOGIC_VECTOR(1535 downto 0);
			bits: in STD_LOGIC;
			enable: in STD_LOGIC);
end shiftreg1536;

architecture arch of shiftreg1536 is
   signal parallel:STD_LOGIC_VECTOR(1535 downto 0);
begin

	process(clk, rst, enable)
	begin
		
		if rst='0' then
			parallel<= (others=>'0');
		elsif clk'event and clk='1' then
			if enable='1' then
				if bits = '0' then
					parallel(1535 downto 1) <= parallel(1534 downto 0);
					parallel(0) <= shiftin(0);
				else
					parallel(1535 downto 8) <= parallel(1527 downto 0);
					parallel(7 downto 0) <= shiftin(7 downto 0);
				end if;
			else
				parallel <= parallel;
			end if;
		end if;
		
	end process;
	parallel_out<=parallel;

end arch;