library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity echo_round is
    Port (  round_in : in  STD_LOGIC_VECTOR (2047 downto 0);
            round_out : out  STD_LOGIC_VECTOR (2047 downto 0);
			round_counter : in  STD_LOGIC_VECTOR (2 downto 0);
			bit_counter:in std_logic_vector(63 downto 0));
end echo_round;

architecture Behavioral of echo_round is

	--component declarations
	component BigSubWords is 
		port (	subwords_in : in std_logic_vector(2047 downto 0);
				subwords_out : out std_logic_vector(2047 downto 0);
				counter : in std_logic_vector(63 downto 0);
				round_counter:in std_logic_vector(2 downto 0));
	end component;
	
	component BigShiftRow is 
	port (	shiftrow_in : in std_logic_vector(2047 downto 0);
			shiftrow_out : out std_logic_vector(2047 downto 0));
	end component;
	
	component BigMixColumn is 
	port (	mixcolumn_in : in std_logic_vector(2047 downto 0);
			mixcolumn_out : out std_logic_vector(2047 downto 0));
	end component;

	--signal declarations
	signal afterbsw: std_logic_vector(2047 downto 0);
	signal afterbsr: std_logic_vector(2047 downto 0);


begin

	--componenten instances
	inst_BSW: BigSubWords
		port map(round_in, afterbsw, bit_counter, round_counter);
				
	inst_BSR: BigShiftRow
		port map(afterbsw, afterbsr);

	inst_BMC: BigMixColumn
		port map(afterbsr, round_out);
			
	
end Behavioral;

