library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity BigSubWords is 
	port (	subwords_in : in std_logic_vector(2047 downto 0);
			subwords_out : out std_logic_vector(2047 downto 0);
			counter : in std_logic_vector(63 downto 0);
			round_counter:in std_logic_vector(2 downto 0));
end entity;

architecture BigSubWords_arch of BigSubWords is
	
	--components
	component AESround is
    Port (  AESinput : in  STD_LOGIC_VECTOR (127 downto 0);
            AESoutput : out  STD_LOGIC_VECTOR (127 downto 0);
			AESkey : in  STD_LOGIC_VECTOR (127 downto 0));
	end component;
	
	--signals
	signal total_counter: std_logic_vector(2047 downto 0);
	signal total_counter_little_endian: std_logic_vector(2047 downto 0);
	signal state_after_aes1: std_logic_vector(2047 downto 0);
	signal counter_int: integer;
	signal round_counter_int: integer;
	
begin
	
	----Dit is gewoon de versie waarbij voor ieder woord 2 aesrounds worden aangemaakt.
	-- in zo klein mogelijke versie 16 clk's meer met 2x aesround (pipelined) 16x8.... is nogal een vertraging in totaal...
	-- 1x16 stuks en terugkoppeling? das 1 clkx8 =8clk's meer in totaal en maar de helft nodig, lijkt me goede oplossing
	
	round_counter_int <= CONV_INTEGER(round_counter);
	gen_BS0: for i in 15 downto 0 generate
		total_counter(128*i+127 downto 128*i+64)<= x"0000000000000000";
		total_counter(128*i+63 downto 128*i)<=  STD_LOGIC_VECTOR( counter+(15-i)+(round_counter_int*16));
		total_counter_little_endian(128*i+127 downto 128*i)<=total_counter(128*i+7 downto 128*i+0) & total_counter(128*i+15 downto 128*i+8) & total_counter(128*i+23 downto 128*i+16) & total_counter(128*i+31 downto 128*i+24) & total_counter(128*i+39 downto 128*i+32) & total_counter(128*i+47 downto 128*i+40) & total_counter(128*i+55 downto 128*i+48) & total_counter(128*i+63 downto 128*i+56) & x"0000000000000000";
	end generate;
	
	gen_BS1: for i in 15 downto 0 generate
		inst_AESR1:AESround
		Port map(subwords_in(128*i+127 downto 128*i), state_after_aes1(128*i+127 downto 128*i),total_counter_little_endian(128*i+127 downto 128*i));
	end generate;
	
	gen_BS2: for i in 15 downto 0 generate
		inst_AESR2:AESround
		Port map(state_after_aes1(128*i+127 downto 128*i),subwords_out(128*i+127 downto 128*i),x"00000000000000000000000000000000");
	end generate;
	
end;
