library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Hamsi_256 is
    port(input: in std_logic;
         clk,rst,init,end_last_message,enable:in std_logic;         
         output: out std_logic_vector(255 downto 0);
         done,init_ready: out std_logic
        );
end Hamsi_256;

architecture Behavioral of Hamsi_256 is

component Hamsi_Buffer is
	port (	input,init,end_last_message, clk,rst,enable,NLP_ready: in std_logic;
			 output: out std_logic_vector(31 downto 0);
			 done,data_ready,init_ready,chaining_value_select,last_block: out std_logic);
end component;


component hamsi_coding is
port(input : in std_logic_vector(31 downto 0);
	  clk,rst,Data_ready,chaining_value_select,last_block: in std_logic;
	  initial_chaining_value: in std_logic_vector(255 downto 0);
	
	  output: out std_logic_vector(255 downto 0);
     done,NLPready: out std_logic
     );
end component;
       
signal Message_Expansion_out,NLP_out:std_logic_vector(255 downto 0);
signal Buffer_done,nlp_ready,data_ready_int,init_ready_int,chaining_value_select,last_block: std_logic;
signal concatenation_out: std_logic_vector(511 downto 0);
signal Buffer_out: std_logic_vector(31 downto 0);
signal initial_chaining_value: std_logic_vector(255 downto 0):= x"766572736974656974204c657576656e2c20446570617274656d656e7420456c";


begin   
inst_Buffer : Hamsi_Buffer
      port map(input,init,end_last_message,clk,rst,enable,NLP_ready,Buffer_out,Buffer_done,
               data_ready_int,init_ready_int,chaining_value_select,last_block);
               

--inst_Hamsi_coding : hamsi_coding
--		port map(buffer_out,clk,rst,Buffer_done,Data_ready_int,chaining_Value_select,last_block,
--					initial_chaining_value,nlp_out,done,NLP_ready);

inst_Hamsi_coding : hamsi_coding
		port map(buffer_out,clk,rst,Data_ready_int,chaining_Value_select,last_block,
					initial_chaining_value,nlp_out,done,NLP_ready);
					
init_ready<=init_ready_int;

          

output <= nlp_out;
        
end Behavioral;