----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:59:25 11/19/2009 
-- Design Name: 
-- Module Name:    hamsi_coding - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity hamsi_coding is
port(input : in std_logic_vector(31 downto 0);
	  clk,rst,Data_ready,chaining_value_select,last_block: in std_logic;
	  initial_chaining_value: in std_logic_vector(255 downto 0);
	
	  output: out std_logic_vector(255 downto 0);
     done,NLPready: out std_logic);
end hamsi_coding;

architecture Behavioral of hamsi_coding is
    
component NLP is
    port(input: in std_logic_vector(511 downto 0);
			
         clk,rst,last_NLP,data_ready:in std_logic;         
         output: out std_logic_vector(255 downto 0);
         done,NLP_ready: out std_logic);
end component;

component Data_ready_fsm is
	port (	data_ready_in,clk,rst: in std_logic;
			 Data_ready: out std_logic);
end component;

component MessageExpansion is
    port(input : in std_logic_vector(31 downto 0);
         output: out std_logic_vector(255 downto 0));
end component;

component Concatenation is
    port(C_message,C_chaining_value: in std_logic_vector(255 downto 0);
         C_out: out std_logic_vector(511 downto 0));
end Component;

signal NLP_ready,nlp_Ready_out: std_logic;
signal concatenation_out : std_logic_vector(511 downto 0);
signal Message_Expansion_out,NLP_out,cv_reg,cv_in,output_internal:std_logic_vector(255 downto 0);


begin

NLPready <= nlp_ready_out;

inst_MessageExpansion : MessageExpansion
      port map(input,Message_expansion_out);
        
inst_Concatenation : Concatenation
      port map(message_expansion_out,cv_reg,concatenation_out);
          
inst_NLP : NLP
      port map(concatenation_out,clk,rst,last_block,data_ready,NLP_out,done,nlp_ready);

CV_Select_proc: process(chaining_Value_select,output_internal,initial_chaining_value)
begin
	case chaining_value_select is				
		when '0' =>
			cv_in <= initial_chaining_value;
		when '1' =>
			cv_in <= output_internal;
		when others =>
		   cv_in <= output_internal xor cv_reg;
	end case;
end process;

inst_Data_ready_fsm_6bc: Data_ready_fsm
	port map (	nlp_ready,clk,rst,nlp_Ready_out);

cv_REg_proc: process(clk,rst)
begin
   if rst = '1' then
      cv_REg <= (others => '0');
   elsif rising_edge(clk) then
		if nlp_ready_out='1' then
			cv_reg <= cv_in;
		end if;
   end if;
end process;



output_internal <= NLP_out xor cv_reg;

output <= output_internal;

end Behavioral;

