
-- telt aantal keer dat er een enable wordt gegeven en dus hoeveel bits er al in de buffer zitten
-- als buffer vol zit, dus 6e bit=1 dan zal de enable_buffer laag worden om op die manier met 
-- een and-poort de enable nr de buffer te blokkeren

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Counter6bit is
    port(enable_6bc, clk, rst: in std_logic;
         enable_buffer: out std_logic;
         output: out std_logic_vector(5 downto 0)
        );
end Counter6bit;

architecture Behavioral of Counter6bit is 


signal counter_reg : std_logic_vector(5 downto 0);
begin
counter: process (clk,rst)
   begin
       if rst = '1' then
           counter_reg <= (others => '0');
       elsif rising_edge(clk) then
           if enable_6bc= '1' then
               counter_reg <= counter_reg + 1;
           else
               counter_reg <= counter_reg;
           end if;
       end if;
       
end process;
output <= counter_reg;
enable_buffer <= not(counter_reg(5));
  
   

end Behavioral;

         