library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Concatenation is
    port(C_message,C_chaining_value: in std_logic_vector(255 downto 0);
         C_out: out std_logic_vector(511 downto 0)
        );
end Concatenation;

architecture Behavioral of Concatenation is 


signal c0,c1,c2,c3,c4,c5,c6,c7,m0,m1,m2,m3,m4,m5,m6,m7 : std_logic_vector(31 downto 0);
begin

c7 <= C_chaining_value(31 downto 0);
c6 <= C_chaining_value(63 downto 32);
c5 <= C_chaining_value(95 downto 64);
c4 <= C_chaining_value(127 downto 96);
c3 <= C_chaining_value(159 downto 128);
c2 <= C_chaining_value(191 downto 160);
c1 <= C_chaining_value(223 downto 192);
c0 <= C_chaining_value(255 downto 224);

m0 <= C_message(31 downto 0);
m1 <= C_message(63 downto 32);
m2 <= C_message(95 downto 64);
m3 <= C_message(127 downto 96 );
m4 <= C_message(159 downto 128);
m5 <= C_message(191 downto 160);
m6 <= C_message(223 downto 192);
m7 <= C_message(255 downto 224);

c_out <= m0 & m1 & c0 & c1 & c2 & c3 & m2 & m3 & m4 & m5 & c4 & c5 & c6 & c7 & m6 & m7;

end Behavioral;