library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity Diffusion is
   port( Dif_input :in std_logic_vector( 127 downto 0 );
         Dif_output :out std_logic_vector( 127 downto 0 )
        
);
end Diffusion;

architecture Behavioral of Diffusion is






signal a, b, c, d : std_logic_vector(31 downto 0);
signal tmpa : std_logic_vector(31 downto 0);
signal tmpb : std_logic_vector(31 downto 0);
signal tmpc : std_logic_vector(31 downto 0);
signal tmpd : std_logic_vector(31 downto 0);
signal tmpa2,tmpa3,tmpa4 : std_logic_vector(31 downto 0);
signal tmpb2,tmpb3 : std_logic_vector(31 downto 0);
signal tmpc2,tmpc3 : std_logic_vector(31 downto 0);
signal tmpd2 : std_logic_vector(31 downto 0);


Begin

---- verdelen van 128bits in 4x 32 bits en bepalen wat aan ingang komt te hangen


  a(31 downto 0) <= Dif_input(127 downto 96);
  b(31 downto 0) <= Dif_input(95 downto 64);
  c(31 downto 0) <= Dif_input(63 downto 32);
  d(31 downto 0) <= Dif_input(31 downto 0);

--diffusion

  tmpa(31 downto 13) <= a(18 downto 0) ; -- left rotate a 13 times
  tmpa(12 downto 0) <= a(31 downto 19) ; 
  tmpc(31 downto 3) <= c(28 downto 0) ; --left rotate c 3 times
  tmpc(2 downto 0) <= c(31 downto 29) ; 
  tmpb <= b xor tmpa xor tmpc ;
  tmpa2(31 downto 3) <= tmpa(28 downto 0); --left shift a 3 times
  tmpa2(2 downto 0) <= "000"; 
  tmpd <= d xor tmpc xor tmpa2 ;
  tmpb2 (31 downto 1)<= tmpb(30 downto 0); --left rotate b 1time
  tmpb2 (0) <= tmpb(31);
  tmpb2 (31 downto 1)<= tmpb( 30 downto 0);
  tmpb2 (0) <= tmpb(31);
  tmpd2 (31 downto 7)<= tmpd(24 downto 0); --left rotate d 7 times
  tmpd2 (6 downto 0) <= tmpd(31 downto 25);
  tmpa3 <= tmpa xor tmpb2 xor tmpd2;
  tmpb3 (31 downto 7)<= tmpb2(24 downto 0); --left shift b 7 times
  tmpb3 (6 downto 0) <= "0000000";
  tmpc2 <= tmpc xor tmpd2 xor tmpb3;
  tmpa4(31 downto 5) <= tmpa3(26 downto 0) ; --left rotate a 5 times
  tmpa4(4 downto 0) <= tmpa3(31 downto 27) ;
  tmpc3 (31 downto 22) <= tmpc2(9 downto 0); --left rotate c 22 times
  tmpc3 (21 downto 0) <= tmpc2(31 downto 10);
  Dif_output <= tmpa4 & tmpb2 & tmpc3 & tmpd2;
  
  end Behavioral;
  