----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:59:25 11/19/2009 
-- Design Name: 
-- Module Name:    hamsi_coding - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity hamsi_coding is
port(input : in std_logic_vector(31 downto 0);
	  clk,rst,Data_ready,chaining_value_select,last_block: in std_logic;
	  initial_chaining_value: in std_logic_vector(255 downto 0);
	
	  output: out std_logic_vector(255 downto 0);
     done,NLPready: out std_logic);
end hamsi_coding;

architecture Behavioral of hamsi_coding is
    
component NLP is
    port(input: in std_logic_vector(511 downto 0);
         Counter_value: in std_logic_vector(4 downto 0);
			last_nlp: in std_logic;
         output: out std_logic_vector(511 downto 0));
end component;

component Data_ready_fsm is
	port (	data_ready_in,clk,rst: in std_logic;
			 Data_ready: out std_logic);
end component;

component MessageExpansion is
    port(input : in std_logic_vector(31 downto 0);
         output: out std_logic_vector(255 downto 0));
end component;

component Concatenation is
    port(C_message,C_chaining_value: in std_logic_vector(255 downto 0);
         C_out: out std_logic_vector(511 downto 0));
end Component;

type my_state is (waiting,running);
signal state :my_state;

signal nlp_Ready_out,load_tmp: std_logic;
signal concatenation_out : std_logic_vector(511 downto 0);
signal Message_Expansion_out,cv_reg,cv_in,output_internal:std_logic_vector(255 downto 0);
signal nlp1,nlp2,nlp3,nlp4,nlp5,nlp6 : std_logic_vector(511 downto 0);
signal counter_value1 : std_logic_Vector(4 downto 0) ;
signal counter_value2 : std_logic_Vector(4 downto 0) ;
signal counter_value3 : std_logic_Vector(4 downto 0) ;
signal counter_value4 : std_logic_Vector(4 downto 0) ;
signal counter_value5 : std_logic_Vector(4 downto 0) ;
signal counter_value6 : std_logic_Vector(4 downto 0) ;
signal temp_reg : std_logic_Vector(511 downto 0) ;


begin
counter_value1 <= "00000";
counter_value2 <= "00001";
counter_value3 <= "00010";
counter_value4 <= "00011";
counter_value5 <= "00100";
counter_value6 <= "00101";

NLPready <= nlp_ready_out;

inst_MessageExpansion : MessageExpansion
      port map(input,Message_expansion_out);
        
inst_Concatenation : Concatenation
      port map(message_expansion_out,cv_reg,concatenation_out);
          
inst_NLP1 : NLP
      port map(concatenation_out,counter_value1,last_block,NLP1);

inst_NLP2 : NLP
      port map(NLP1,counter_value2,last_block,NLP2);

inst_NLP3 : NLP
      port map(NLP2,counter_value3,last_block,NLP3);
		
inst_NLP4 : NLP
      port map(NLP3,counter_value4,last_block,NLP4);

inst_NLP5 : NLP
      port map(NLP4,counter_value5,last_block,NLP5);

inst_NLP6 : NLP
      port map(NLP5,counter_value6,last_block,NLP6);
		
CV_Select_proc: process(chaining_Value_select,output_internal,initial_chaining_value)
begin
	case chaining_value_select is				
		when '0' =>
			cv_in <= initial_chaining_value;
		when '1' =>
			cv_in <= output_internal;
		when others =>
		   cv_in <= output_internal xor cv_reg;
	end case;
end process;


cv_REg_proc: process(clk,rst)
begin
   if rst = '1' then
      cv_REg <= (others => '0');
   elsif rising_edge(clk) then
		if  data_ready = '1' then
			cv_reg <= cv_in;
		end if;
   end if;
end process;



output_internal <= (temp_reg(511 downto 384) & temp_reg( 255 downto 128)) xor cv_reg;

output <= (nlp6(511 downto 384) & nlp6( 255 downto 128)) xor cv_reg;

load_temp: process(clk,rst)
begin
   if rst = '1' then
      temp_reg <= (others => '0');
   elsif rising_edge(clk) then
		if load_tmp ='1' then
				temp_reg <= nlp3;
		end if;
	end if;
end process;


fsm: process(rst,clk)
begin
			if rst = '1' then        
   			   load_tmp <= '0';
   			   NLP_ready_out <= '0';
   			   state <= waiting;				
			elsif rising_edge(clk) then
				case state is
				   when waiting =>
						if data_ready = '1' then
							   load_tmp <= '1';
								NLP_ready_out <= '0';
								state <= running;	
						else 
								load_tmp <= '0';
								state <= waiting;
								NLP_ready_out <= '0';
						end if;								
					when running =>
					   	load_tmp <= '0';
							NLP_ready_out <= '1';	
        			      state <= waiting;
					when others =>	
					
					   	load_tmp <= '0';
							NLP_ready_out <= '0';	
        			      state <= waiting;
					end case;
			end if;
	end process;
end Behavioral;


