
---------------------------------------
--
-- Testbench voor LANE hashfunctie
--
-- Masterproef 
--
---------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity TB_Lane is
end TB_Lane;

architecture behav of TB_Lane is
    
    component Lane_block is
    Port (  chaining_value : in  STD_LOGIC_VECTOR (255 downto 0);
            message_block : in  STD_LOGIC_VECTOR (511 downto 0);
            rst, clk : in STD_LOGIC;
			start : in  STD_LOGIC;
            done : out  STD_LOGIC;
			bit_counter : in STD_LOGIC_VECTOR(63 downto 0);
			hash_out: out STD_LOGIC_VECTOR(255 downto 0));
    end component;
 
	--signalen
	SIGNAL chaining_value : STD_LOGIC_VECTOR(255 downto 0);
   SIGNAL message_block : STD_LOGIC_VECTOR(511 downto 0);       
	SIGNAL clk :  std_logic := '0';
	SIGNAL rst :  std_logic := '0';
	SIGNAL start :  std_logic := '0';
	SIGNAL done :  std_logic;
	SIGNAL bit_counter : STD_LOGIC_VECTOR(63 downto 0);
	SIGNAL hash_out: STD_LOGIC_VECTOR(255 downto 0);
    
	--signalen en constanten voor simulatiedoeleinden
	signal EndOfSim   : boolean:=false;
	constant ClkPeriod : time := 10 ns;
	constant startlevel: std_logic := '0';
  
begin
    
	inst_Lane: Lane_block
    port map(chaining_value,message_block ,rst, clk,start,done,bit_counter,hash_out);
    
	
	p_clk: process
	begin
		loop
        exit when EndOfSim;
        clk <= startlevel;
        wait for CLKPeriod / 2;
        exit when EndOfSim;
        clk <= not startlevel;
        wait for CLKPeriod - (CLKPeriod / 2); 
      end loop;
	end process;
	
	
	testprocess: process
	begin
					EndOfSim <= false;
					wait for 10ns;
					bit_counter <=   "0000000000000000000000000000000000000000000000000000000111110000"; --zet de bitcounter op 496
					chaining_value<=x"be292e17bb541ff2fe54b6f730b1c96a7b2592688539bdf397c4bdd649763fb8"; --steek de IV voor LANE 256 in de chaining value
					message_block <=x"6162636465666768696a6b6c6d6e6f707172737475767778797a4142434445464748494a4b4c4d4e4f505152535455565758595a303132333435363738390000"; --zie testgegevens
					rst<='1'; --laag actieve reset
					start<='1';
					report"*-*-*-*-*-*-*-*-*-*Start simulatie*-*-*-*-*-*-*-*-*";
					wait for 10ns;
					start<='0';
					wait until done = '1';
					EndOfSim <= true;
					wait for 1ns;
					
					--nu kijken of op de uitgang staat wat er moet staan (waarde komt van C-referentie implementatie)
					Assert( hash_out = x"6CEBA96143E326C8754B16A771897CA24EB9EC369A43C2DD496E7EC096206DCB" ) report "De bekomen eindhashwaarde is fout!" severity ERROR;
					--voor hashstring=abcdefg
					report"*-*-*-*-*-*-*-*-*-*Einde simulatie*-*-*-*-*-*-*-*-*";
					--wait; --blijf wachten tot oneindig
	  
    end process;
    
end behav;

   