----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    02:53:55 04/08/2010 
-- Design Name: 
-- Module Name:    Luffa_256 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity MI_P is
    Port (
           H0_in  :in  std_logic_vector( 255 downto 0 );
			  H1_in  :in  std_logic_vector( 255 downto 0 );
           H2_in  :in  std_logic_vector( 255 downto 0 );
			  input  :in  std_logic_vector( 255 downto 0 );
			  Q0_out :out std_logic_vector( 255 downto 0 );
           Q1_out :out std_logic_vector( 255 downto 0 );
           Q2_out :out std_logic_vector( 255 downto 0 )
			 
         );
end MI_P;

architecture Behavioral of MI_P is

component Message_injection is
   port( H0_in  :in  std_logic_vector( 255 downto 0 );
         H1_in  :in  std_logic_vector( 255 downto 0 );
         H2_in  :in  std_logic_vector( 255 downto 0 );
         Message  :in  std_logic_vector( 255 downto 0 );
         H0_out :out std_logic_vector( 255 downto 0 );
         H1_out :out std_logic_vector( 255 downto 0 );
         H2_out :out std_logic_vector( 255 downto 0 )
         
);
end component;

component Permutation is
   port( Q0_in  :in  std_logic_vector( 255 downto 0 );
         Q1_in  :in  std_logic_vector( 255 downto 0 );
         Q2_in  :in  std_logic_vector( 255 downto 0 );
         Q0_out :out std_logic_vector( 255 downto 0 );
         Q1_out :out std_logic_vector( 255 downto 0 );
         Q2_out :out std_logic_vector( 255 downto 0 )
         
);
end component;

component Tweak is
   port( Tweak_in  :in  std_logic_vector( 255 downto 0 );
         Tweak_out :out std_logic_vector( 255 downto 0 );
			Subperm_select:in std_logic_vector(1 downto 0)
);
end component;


signal Tweak_out0,Tweak_out1,Tweak_out2,H0_out,H1_out,H2_out : std_logic_vector( 255 downto 0 );
signal SubPerm_sel0,SubPerm_sel1,SubPerm_sel2 : std_logic_vector(1 downto 0);


signal c00: std_logic_Vector (95 downto 0) := x"000000000000000000000000";

begin

SubPerm_sel0 <= "00";
SubPerm_sel1 <="01";
SubPerm_sel2 <= "10";

inst_MI: Message_Injection
	port map(H0_in,H1_in,H2_in,input,H0_out,H1_out,H2_out);

 inst_Tweak0 : Tweak
  port map(H0_out,Tweak_out0,SubPerm_sel0);

inst_Tweak1 : Tweak
  port map(H1_out,Tweak_out1,SubPerm_sel1);
  
 inst_Tweak2 : Tweak
  port map(H2_out,Tweak_out2,SubPerm_sel2);	

inst_perm : Permutation 
	port map(Tweak_out0,tweak_out1,Tweak_out2,Q0_out,Q1_out,Q2_out);

end Behavioral;

