library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;



entity Message_injection is
   port( H0_in  :in  std_logic_vector( 255 downto 0 );
         H1_in  :in  std_logic_vector( 255 downto 0 );
         H2_in  :in  std_logic_vector( 255 downto 0 );
         Message  :in  std_logic_vector( 255 downto 0 );
         H0_out :out std_logic_vector( 255 downto 0 );
         H1_out :out std_logic_vector( 255 downto 0 );
         H2_out :out std_logic_vector( 255 downto 0 )
         
);
end Message_injection;

architecture internals of Message_injection is

COMPONENT mult2 is
   port( input :in std_logic_vector( 255 downto 0 );
         output:out std_logic_vector( 255 downto 0 )
);
end COMPONENT;

signal H_mult2,M1,M2,h_xor: std_logic_vector(255 downto 0);


Begin


MULT21 : mult2 
   port map(message,m1);

MULT22 : mult2 
   port map(m1,m2);
	
MULT23 : mult2 
   port map(H_xor,H_mult2);
		

H_xor <= (H0_in xor H1_in xor H2_in);



H0_out <= H0_in xor Message xor h_mult2;
H1_out <= H1_in xor M1 xor h_mult2;
H2_out <= H2_in xor M2 xor H_mult2;


end internals;
