library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;


entity MixData is
   port( MD_in  :in  std_logic_vector( 255 downto 0 );
         MD_out :out std_logic_vector( 255 downto 0 )
);
end MixData;

architecture internals of MixData is

component MixWord is
   port( M_in :in std_logic_vector( 63 downto 0 );
         M_out :out std_logic_vector( 63 downto 0 )
);
end component;

signal MW_in,MW_out: std_logic_vector( 255 downto 0);

Begin

gen_MixWord: for i in 3 downto 0 generate
 inst_MixWord : MixWord
  port map(MW_in(i*64+63 downto i*64),
  			  MW_out(i*64+63 downto i*64));
 end generate;


MW_in(255 downto 192) <= MD_in(255 downto 224) & MD_in(127 downto 96);
MW_in(191 downto 128) <= MD_in(223 downto 192) & MD_in(95 downto 64);
MW_in(127 downto 64)  <= MD_in(191 downto 160) & MD_in(63 downto 32);
MW_in(63 downto 0)  <= MD_in(159 downto 128) & MD_in(31 downto 0);
 

MD_out(255 downto 192) <= mw_out(255 downto 224) & mw_out(191 downto 160);
MD_out(191 downto 128) <= mw_out(127 downto 96) & mw_out(63 downto 32);
MD_out(127 downto 64)  <= mw_out(223 downto 192) & mw_out(159 downto 128);
MD_out(63 downto 0)  <= mw_out(95 downto 64) & mw_out(31 downto 0);
end internals;
