library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;


entity Step is
   port( Step_in  :in  std_logic_vector( 255 downto 0 );
         Step_out :out std_logic_vector( 255 downto 0 )         
);
end Step;

architecture internals of Step is

component SubCrumb is
   port( SubCrumb_in :in std_logic_vector( 127  downto 0 );
         SubCrumb_out :out std_logic_vector( 127 downto 0 ));
end component;

component MixData is
   port( MD_in  :in  std_logic_vector( 255 downto 0 );
         MD_out :out std_logic_vector( 255 downto 0 )
);
end component;



signal S_out: std_logic_vector(255 downto 0);
signal SC2_in,SC2_out: std_logic_vector(127 downto 0);
Begin


 inst_SubCrumb1 : SubCrumb
  port map(Step_in(255 downto 128),S_out(255 downto 128));

sc2_in <= Step_in(95 downto 0) & Step_in(127 downto 96);
 
inst_subcrumb2 : SubCrumb
	port map(SC2_in,SC2_out);
	
S_out(127 downto 0) <= SC2_out(31 downto 0) & SC2_out(127 downto 32);

inst_MD : MixData
       port map(S_out,Step_out);

end internals;
