library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;


entity SubCrumb is
   port( SubCrumb_in  :in  std_logic_vector( 127 downto 0 );
         SubCrumb_out :out std_logic_vector( 127 downto 0 )
);
end Subcrumb;

architecture internals of SubCrumb is

component Sbox is
   port( Sbox_in :in std_logic_vector( 3 downto 0 );
         Sbox_out :out std_logic_vector( 3 downto 0 ));
end component;

signal Sbox_in,Sbox_out : std_logic_vector(127 downto 0);

Begin

gen_Sbox: for i in 31 downto 0 generate
 inst_Sbox : Sbox
  port map(Sbox_in(4*i+3 downto 4*i),Sbox_out(4*i+3 downto 4*i));

 end generate;

gen_Sbox_in: for i in 31 downto 0 generate
  Sbox_in(4*i+3) <= SubCrumb_in(i);
  Sbox_in(4*i+2) <= SubCrumb_in(i+32);
  Sbox_in(4*i+1) <= SubCrumb_in(i+64);
  Sbox_in(4*i+0) 	<= SubCrumb_in(i+96);

  SubCrumb_out(i) 	<= Sbox_out(4*i+3);
  SubCrumb_out(i+32) <= Sbox_out(4*i+2);
  SubCrumb_out(i+64) <= Sbox_out(4*i+1);
  SubCrumb_out(i+96) <= Sbox_out(4*i);

  
 end generate;

end internals;
