library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Luffa_256 is
    Port ( data_Ready,clk,rst : in  STD_LOGIC;
           input : in  STD_LOGIC_vector(255 downto 0);
           output : out  STD_LOGIC_vector(255 downto 0)
         );
end Luffa_256;

architecture Behavioral of Luffa_256 is

component MI_P is
    Port ( data_Ready : in  STD_LOGIC;
           H0_in  :in  std_logic_vector( 255 downto 0 );
			  H1_in  :in  std_logic_vector( 255 downto 0 );
           H2_in  :in  std_logic_vector( 255 downto 0 );
			  Input  :in  std_logic_vector( 255 downto 0 );
			  Q0_out :out std_logic_vector( 255 downto 0 );
           Q1_out :out std_logic_vector( 255 downto 0 );
           Q2_out :out std_logic_vector( 255 downto 0 )
			 
         );
end component;




signal Q0_reg,Q1_reg,Q2_reg,input_int,Q0_MP,Q1_MP,Q2_MP,H0_init,H1_init,H2_init: std_logic_vector( 255 downto 0 );


signal V00: std_logic_vector(31 downto 0)  := x"6d251e69";
signal V01: std_logic_vector(31 downto 0)  := x"44b051e0";
signal V02: std_logic_vector(31 downto 0)  := x"4eaa6fb4"; 
signal V03: std_logic_vector(31 downto 0)  := x"dbf78465";
signal V04: std_logic_vector(31 downto 0)  := x"6e292011"; 
signal V05: std_logic_vector(31 downto 0)  := x"90152df4"; 
signal V06: std_logic_vector(31 downto 0)  := x"ee058139"; 
signal V07: std_logic_vector(31 downto 0)  := x"def610bb";

signal V10: std_logic_vector(31 downto 0)  := x"c3b44b95"; 
signal V11: std_logic_vector(31 downto 0)  := x"d9d2f256"; 
signal V12: std_logic_vector(31 downto 0)  := x"70eee9a0"; 
signal V13: std_logic_vector(31 downto 0)  := x"de099fa3";
signal V14: std_logic_vector(31 downto 0)  := x"5d9b0557"; 
signal V15: std_logic_vector(31 downto 0)  := x"8fc944b3";
signal V16: std_logic_vector(31 downto 0)  := x"cf1ccf0e"; 
signal V17: std_logic_vector(31 downto 0)  := x"746cd581";

signal V20: std_logic_vector(31 downto 0)  := x"f7efc89d"; 
signal V21: std_logic_vector(31 downto 0)  := x"5dba5781"; 
signal V22: std_logic_vector(31 downto 0)  := x"04016ce5"; 
signal V23: std_logic_vector(31 downto 0)  := x"ad659c05";
signal V24: std_logic_vector(31 downto 0)  := x"0306194f"; 
signal V25: std_logic_vector(31 downto 0)  := x"666d1836"; 
signal V26: std_logic_vector(31 downto 0)  := x"24aa230a"; 
signal V27: std_logic_vector(31 downto 0)  := x"8b264ae7";
signal counter: std_logic_vector(4 downto 0);

Begin






inst_MI_P : MI_P 
	port map(data_Ready,Q0_reg,Q1_reg,Q2_reg,input,Q0_MP,Q1_MP,Q2_MP);

H0_init <= V00 & V01 & V02 & V03 & V04 & V05 & V06 & V07 ;
H1_init <= V10 & V11 & V12 & V13 & V14 & V15 & V16 & V17 ;
H2_init <= V20 & V21 & V22 & V23 & V24 & V25 & V26 & V27 ;

Q012_proc: process(clk,rst)
begin
	if rst = '1' then
		Q0_reg <= H0_init;
		Q1_reg <= H1_init;
		Q2_reg <= H2_init;
	elsif rising_edge(clk) then
	  if data_ready = '1' then
		Q0_reg <= Q0_MP;
		Q1_reg <= Q1_MP;
		Q2_reg <= Q2_MP;
	  
	  else
		Q0_reg <= Q0_reg;
		Q1_reg <= Q1_reg;
		Q2_reg <= Q2_reg;
	end if;
	END IF;
end process;

output <= Q0_reg xor Q1_reg xor Q2_reg;

end Behavioral;