
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Luffa_clocked is
    port(h0_in,h1_in,h2_in: in std_logic_vector(255 downto 0);
         clk,rst,data_ready:in std_logic;         
         Q0_out,Q1_out,Q2_out: out std_logic_vector(255 downto 0);
         NLP_ready: out std_logic
        );
end Luffa_clocked;

architecture Behavioral of Luffa_clocked is
   



component NLPbitCounter is
    port(Counter_enable,clk,rst: in std_logic;
         Counter_out: out std_logic_vector(4 downto 0));
end component;

component Round is
   port( Q0_in  :in  std_logic_vector( 255 downto 0 );
         Q1_in  :in  std_logic_vector( 255 downto 0 );
         Q2_in  :in  std_logic_vector( 255 downto 0 );
         Q0_out :out std_logic_vector( 255 downto 0 );
         Q1_out :out std_logic_vector( 255 downto 0 );
         Q2_out :out std_logic_vector( 255 downto 0 );
			c10_in, C14_in,c20_in, C24_in,c30_in, C34_in:  in std_logic_vector(31 downto 0));
end component;
  
signal C100: std_logic_vector(31 downto 0)  := x"303994a6";
signal C200: std_logic_vector(31 downto 0)  := x"c0e65299";
signal C300: std_logic_vector(31 downto 0)  := x"6cc33a12";
signal C400: std_logic_vector(31 downto 0)  := x"dc56983e";
signal C500: std_logic_vector(31 downto 0)  := x"1e00108f";
signal C600: std_logic_vector(31 downto 0)  := x"7800423d";
signal C700: std_logic_vector(31 downto 0)  := x"8f5b7882";
signal C800: std_logic_vector(31 downto 0)  := x"96e1db12";

signal C104: std_logic_vector(31 downto 0)  := x"e0337818";
signal C204: std_logic_vector(31 downto 0)  := x"441ba90d";
signal C304: std_logic_vector(31 downto 0)  := x"7f34d442";
signal C404: std_logic_vector(31 downto 0)  := x"9389217f";
signal C504: std_logic_vector(31 downto 0)  := x"e5a8bce6";
signal C604: std_logic_vector(31 downto 0)  := x"5274baf4";
signal C704: std_logic_vector(31 downto 0)  := x"26889ba7";
signal C804: std_logic_vector(31 downto 0)  := x"9a226e9d";

signal C110: std_logic_vector(31 downto 0)  := x"b6de10ed";
signal C210: std_logic_vector(31 downto 0)  := x"70f47aae";
signal C310: std_logic_vector(31 downto 0)  := x"0707a3d4";
signal C410: std_logic_vector(31 downto 0)  := x"1c1e8f51";
signal C510: std_logic_vector(31 downto 0)  := x"707a3d45";
signal C610: std_logic_vector(31 downto 0)  := x"aeb28562";
signal C710: std_logic_vector(31 downto 0)  := x"baca1589";
signal C810: std_logic_vector(31 downto 0)  := x"40a46f3e";

signal C114: std_logic_vector(31 downto 0)  := x"01685f3d";
signal C214: std_logic_vector(31 downto 0)  := x"05a17cf4";
signal C314: std_logic_vector(31 downto 0)  := x"bd09caca";
signal C414: std_logic_vector(31 downto 0)  := x"f4272b28";
signal C514: std_logic_vector(31 downto 0)  := x"144ae5cc";
signal C614: std_logic_vector(31 downto 0)  := x"faa7ae2b";
signal C714: std_logic_vector(31 downto 0)  := x"2e48f1c1";
signal C814: std_logic_vector(31 downto 0)  := x"b923c704";

signal C120: std_logic_vector(31 downto 0)  := x"fc20d9d2";
signal C220: std_logic_vector(31 downto 0)  := x"34552e25";
signal C320: std_logic_vector(31 downto 0)  := x"7ad8818f";
signal C420: std_logic_vector(31 downto 0)  := x"8438764a";
signal C520: std_logic_vector(31 downto 0)  := x"bb6de032";
signal C620: std_logic_vector(31 downto 0)  := x"edb780c8";
signal C720: std_logic_vector(31 downto 0)  := x"d9847356";
signal C820: std_logic_vector(31 downto 0)  := x"a2c78434";

signal C124: std_logic_vector(31 downto 0)  := x"e25e72c1";
signal C224: std_logic_vector(31 downto 0)  := x"e623bb72";
signal C324: std_logic_vector(31 downto 0)  := x"5c58a4a4";
signal C424: std_logic_vector(31 downto 0)  := x"1e38e2e7";
signal C524: std_logic_vector(31 downto 0)  := x"78e38b9d";
signal C624: std_logic_vector(31 downto 0)  := x"27586719";
signal C724: std_logic_vector(31 downto 0)  := x"36eda57f";
signal C824: std_logic_vector(31 downto 0)  := x"703aace7";

signal V00: std_logic_vector(31 downto 0)  := x"6d251e69";
signal V01: std_logic_vector(31 downto 0)  := x"44b051e0";
signal V02: std_logic_vector(31 downto 0)  := x"4eaa6fb4"; 
signal V03: std_logic_vector(31 downto 0)  := x"dbf78465";
signal V04: std_logic_vector(31 downto 0)  := x"6e292011"; 
signal V05: std_logic_vector(31 downto 0)  := x"90152df4"; 
signal V06: std_logic_vector(31 downto 0)  := x"ee058139"; 
signal V07: std_logic_vector(31 downto 0)  := x"def610bb";

signal V10: std_logic_vector(31 downto 0)  := x"c3b44b95"; 
signal V11: std_logic_vector(31 downto 0)  := x"d9d2f256"; 
signal V12: std_logic_vector(31 downto 0)  := x"70eee9a0"; 
signal V13: std_logic_vector(31 downto 0)  := x"de099fa3";
signal V14: std_logic_vector(31 downto 0)  := x"5d9b0557"; 
signal V15: std_logic_vector(31 downto 0)  := x"8fc944b3";
signal V16: std_logic_vector(31 downto 0)  := x"cf1ccf0e"; 
signal V17: std_logic_vector(31 downto 0)  := x"746cd581";

signal V20: std_logic_vector(31 downto 0)  := x"f7efc89d"; 
signal V21: std_logic_vector(31 downto 0)  := x"5dba5781"; 
signal V22: std_logic_vector(31 downto 0)  := x"04016ce5"; 
signal V23: std_logic_vector(31 downto 0)  := x"ad659c05";
signal V24: std_logic_vector(31 downto 0)  := x"0306194f"; 
signal V25: std_logic_vector(31 downto 0)  := x"666d1836"; 
signal V26: std_logic_vector(31 downto 0)  := x"24aa230a"; 
signal V27: std_logic_vector(31 downto 0)  := x"8b264ae7";

type my_state is (idle,running);
signal state : my_state;

signal out_Counter : std_logic_vector(4 downto 0);
signal enable_counter,rst_counter,reset_counter,load: std_logic;
signal counter: std_logic_vector(4 downto 0);
signal CR10_in, CR14_in,cR20_in, CR24_in,cR30_in, CR34_in:std_logic_vector(31 downto 0);
signal R0_out,R1_out,r2_out,R0_in,R1_in,r2_in,Q0_reg,Q1_reg,Q2_reg,input_int,Q0_MP,Q1_MP,Q2_MP,H0_init,H1_init,H2_init: std_logic_vector( 255 downto 0 );

Begin

inst_counter: NLPbitCounter
   port map( enable_counter,clk,rst_counter,out_counter); --rst_counter

rst_counter<=rst or reset_counter;

H0_init <= V00 & V01 & V02 & V03 & V04 & V05 & V06 & V07 ;
H1_init <= V10 & V11 & V12 & V13 & V14 & V15 & V16 & V17 ;
H2_init <= V20 & V21 & V22 & V23 & V24 & V25 & V26 & V27 ;

Q012_proc: process(clk,rst)
begin
	if rst = '1' then
		Q0_reg <= H0_init;
		Q1_reg <= H1_init;
		Q2_reg <= H2_init;
	elsif rising_edge(clk) then
	  if load = '1' then
		Q0_reg <= R0_out;
		Q1_reg <= R1_out;
		Q2_reg <= R2_out;	  
	  else
		Q0_reg <= Q0_reg;
		Q1_reg <= Q1_reg;
		Q2_reg <= Q2_reg;
	end if;
	END IF;
end process;


input_select_proc: process(Q0_reg,Q1_reg,Q2_reg,h0_in,H1_in,h2_in,out_counter)
 begin
     if out_counter = "00000" then
         R0_in <= h0_in;
			R1_in <= h1_in;
			R2_in <= h2_in;
     else
         R0_in <= Q0_reg;
			R1_in <= q1_reg;
			R2_in <= q2_reg;
     end if;
 end process;

Round1: Round 
   port map( R0_in,R1_in,R2_in,R0_out,R1_out,R2_out,CR10_in, CR14_in,cR20_in, CR24_in,cR30_in, CR34_in);

Q0_out <= Q0_reg;
Q1_out <= Q1_reg;
Q2_out <= Q2_reg;

pr_addct: process(out_counter)
begin
			
				case out_counter is
				   when "00000" => 
					CR10_in <= C100;
					CR14_in <= C104;
					cR20_in <= C110; 
					CR24_in <= C114;
					cR30_in <= C120; 
					CR34_in <= C124;
					when "00001" => 
					CR10_in <= C200;
					CR14_in <= C204;
					cR20_in <= C210; 
					CR24_in <= C214;
					cR30_in <= C220; 
					CR34_in <= C224;
					when "00010" => 
					CR10_in <= C300;
					CR14_in <= C304;
					cR20_in <= C310; 
					CR24_in <= C314;
					cR30_in <= C320; 
					CR34_in <= C324;
					when "00011" =>
					CR10_in <= C400;
					CR14_in <= C404;
					cR20_in <= C410; 
					CR24_in <= C414;
					cR30_in <= C420; 
					CR34_in <= C424;
					when "00100" =>
					CR10_in <= C500;
					CR14_in <= C504;
					cR20_in <= C510; 
					CR24_in <= C514;
					cR30_in <= C520; 
					CR34_in <= C524;
					when "00101" => 
					CR10_in <= C600;
					CR14_in <= C604;
					cR20_in <= C610; 
					CR24_in <= C614;
					cR30_in <= C620; 
					CR34_in <= C624;
					when "00110" =>
					CR10_in <= C700;
					CR14_in <= C704;
					cR20_in <= C710; 
					CR24_in <= C714;
					cR30_in <= C720; 
					CR34_in <= C724;
					when "00111" => 
					CR10_in <= C800;
					CR14_in <= C804;
					cR20_in <= C810; 
					CR24_in <= C814;
					cR30_in <= C820; 
					CR34_in <= C824;
					when others =>
					CR10_in <= C100;
					CR14_in <= C104;
					cR20_in <= C110; 
					CR24_in <= C114;
					cR30_in <= C120; 
					CR34_in <= C124;
END CASE;
END PROCESS;

fsm: process(rst,clk)
begin
			if rst = '1' then       
   			   load <= '0';
   			   enable_counter <= '0';
   			   reset_counter <= '1';
   			   NLP_ready <= '1';
   			   state <= idle;				
			elsif rising_edge(clk) then
				case state is
				   when idle =>
					if data_ready = '1' then
   			   		load <= '1';
							enable_counter <= '1';
							reset_counter <= '0';
							NLP_ready <= '0';
							state <= running;
					else 								
           			   load <= '0';								
							enable_counter <= '0';
							reset_counter <= '1';							
							NLP_ready <= '1';
							state <= idle;		
					end if;
					when running =>
					   if out_counter = "00111"  then
   			         load <= '0';
							enable_counter <= '0';
        			      reset_counter <= '1';
							NLP_ready <= '0';	
        			      state <= idle;
						else       
                	   load <= '1';
   			         enable_counter <= '1';
            		   reset_counter <= '0';
            			NLP_ready <= '0';
							state <= running;
   			      end if;
			end case;
		end if;
	end process;  
		
end Behavioral;