library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;


entity MixWord is
   port( M_in :in std_logic_vector( 63 downto 0 );
         M_out :out std_logic_vector( 63 downto 0 )
);
end Mixword;

architecture internals of Mixword is

signal in1,in2,out1,out2: std_logic_vector(31 downto 0);
signal tmp11,tmp12,tmp13,tmp14,tmp21,tmp22,tmp23:std_logic_vector(31 downto 0);

Begin
  in1 <= M_in(63 downto 32);
  in2  <= M_in(31 downto 0);
 
  tmp21 <= in1 xor in2; 

  tmp11(31 downto 2) <= in1(29 downto 0) ; 
  tmp11(1 downto 0) <= in1(31 downto 30) ; 
  
  
  tmp12 <= tmp11 xor tmp21; 
  
  tmp22(31 downto 14) <= tmp21(17 downto 0); 
  tmp22(13 downto 0) <= tmp21(31 downto 18); 

  tmp23 <= tmp22 xor tmp12;

  tmp13(31 downto 10) <= tmp12( 21 downto 0); 
  tmp13(9 downto 0) <= tmp12(31 downto 22); 
  
  out1 <= tmp23 xor tmp13;
  
  out2(31 downto 1) <= tmp23(30 downto 0);
  out2(0) <= tmp23(31);
  
  M_out <= out1 & out2;
  

end internals;
