library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;


entity Round is
   port( Q0_in  :in  std_logic_vector( 255 downto 0 );
         Q1_in  :in  std_logic_vector( 255 downto 0 );
         Q2_in  :in  std_logic_vector( 255 downto 0 );
         Q0_out :out std_logic_vector( 255 downto 0 );
         Q1_out :out std_logic_vector( 255 downto 0 );
         Q2_out :out std_logic_vector( 255 downto 0 );
			c10_in, C14_in,c20_in, C24_in,c30_in, C34_in : in std_logic_vector( 31 downto 0)
         
);
end Round;

architecture internals of Round is

component Step is
   port( Step_in :in std_logic_vector( 255  downto 0 );
         Step_out :out std_logic_vector( 255 downto 0 )
			);
end component;

component addConstants is
   port( C_in :in std_logic_vector( 767 downto 0 );
         C_out :out std_logic_vector( 767 downto 0 );
			c10_in, C14_in,c20_in, C24_in,c30_in, C34_in : in std_logic_vector( 31 downto 0)
         
);
end component;

signal Q,Q_out: std_logic_vector(767 downto 0);
signal Q0,Q1,Q2: std_logic_vector(255 downto 0);
Begin

Q <= Q0 & Q1 & Q2;
Q0_out <= Q_out(767 downto 512);
Q1_out <= Q_out(511 downto 256);
Q2_out <= Q_out(255 downto 0);


gen_step1 : Step 
	port map(Q0_in,Q0);

gen_step2 : Step 
	port map(Q1_in,Q1);

gen_step3 : Step 
	port map(Q2_in,Q2);

            
inst_addCt: addConstants
      port map(Q,Q_out,c10_in, C14_in,c20_in, C24_in,c30_in, C34_in);





end internals;
