--library IEEE;
--use IEEE.STD_LOGIC_1164.all;
--use IEEE.STD_LOGIC_ARITH.all;
--use IEEE.STD_LOGIC_UNSIGNED.all;
--use IEEE.numeric_std.all;
--use ieee.numeric_std.unsigned;
--use ieee.std_logic_arith.unsigned;
library IEEE;
use ieee.std_logic_1164.all;

use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.NUMERIC_std.all;

entity Tweak is
   port( Tweak_in  :in  std_logic_vector( 255 downto 0 );
         Tweak_out :out std_logic_vector( 255 downto 0 );
			subperm_select:in std_logic_vector(1 downto 0)
					
);
end entity;

architecture internals of Tweak is

signal A0,A1,A2,A3,A0_out,A1_out,A2_out,A3_out: std_logic_vector(31 downto 0);


Begin
    
A3 <= tweak_in(127 downto 96);
A2 <= tweak_in(95 downto 64);
A1 <= tweak_in(63 downto 32);
A0 <= tweak_in(31 downto 0);


tweak :process (A0, subperm_select)
begin
	if subperm_select = "00" then 
	A0_out <= A0;
	A1_out <= A1;
	A2_out <= A2;
	A3_out <= A3;
	elsif subperm_select = "01" then
	A0_out <= A0(30 downto 0) & A0(31);
	A1_out <= A1(30 downto 0) & A1(31);
	A2_out <= A2(30 downto 0) & A2(31);
	A3_out <= A3(30 downto 0) & A3(31);
	elsif subperm_select = "10" then
	A0_out <= A0(29 downto 0) & A0(31 downto 30);
	A1_out <= A1(29 downto 0) & A1(31 downto 30);
	A2_out <= A2(29 downto 0) & A2(31 downto 30);
	A3_out <= A3(29 downto 0) & A3(31 downto 30);
	end if;
end process;



Tweak_out <= Tweak_in(255 downto 128) & A3_out & A2_out & A1_out & A0_out;


end internals;
