library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;


entity Permutation is
   port( Q0_in  :in  std_logic_vector( 255 downto 0 );
         Q1_in  :in  std_logic_vector( 255 downto 0 );
         Q2_in  :in  std_logic_vector( 255 downto 0 );
         Q0_out :out std_logic_vector( 255 downto 0 );
         Q1_out :out std_logic_vector( 255 downto 0 );
         Q2_out :out std_logic_vector( 255 downto 0 )
         
);
end Permutation;

architecture internals of Permutation is

component Round is
   port( Q0_in  :in  std_logic_vector( 255 downto 0 );
         Q1_in  :in  std_logic_vector( 255 downto 0 );
         Q2_in  :in  std_logic_vector( 255 downto 0 );
         Q0_out :out std_logic_vector( 255 downto 0 );
         Q1_out :out std_logic_vector( 255 downto 0 );
         Q2_out :out std_logic_vector( 255 downto 0 );
			c10_in, C14_in,c20_in, C24_in,c30_in, C34_in:  in std_logic_vector(31 downto 0));
end component;



signal Q0_out_R1,Q1_out_R1,Q2_out_R1,Q0_out_R2,Q1_out_R2,Q2_out_R2,Q0_out_R3,Q1_out_R3,Q2_out_R3,
		 Q0_out_R4,Q1_out_R4,Q2_out_R4,Q0_out_R5,Q1_out_R5,Q2_out_R5,Q0_out_R6,Q1_out_R6,Q2_out_R6,Q0_out_R7,Q1_out_R7,Q2_out_R7: std_logic_vector(255 downto 0);
signal C100: std_logic_vector(31 downto 0)  := x"303994a6";
signal C200: std_logic_vector(31 downto 0)  := x"c0e65299";
signal C300: std_logic_vector(31 downto 0)  := x"6cc33a12";
signal C400: std_logic_vector(31 downto 0)  := x"dc56983e";
signal C500: std_logic_vector(31 downto 0)  := x"1e00108f";
signal C600: std_logic_vector(31 downto 0)  := x"7800423d";
signal C700: std_logic_vector(31 downto 0)  := x"8f5b7882";
signal C800: std_logic_vector(31 downto 0)  := x"96e1db12";

signal C104: std_logic_vector(31 downto 0)  := x"e0337818";
signal C204: std_logic_vector(31 downto 0)  := x"441ba90d";
signal C304: std_logic_vector(31 downto 0)  := x"7f34d442";
signal C404: std_logic_vector(31 downto 0)  := x"9389217f";
signal C504: std_logic_vector(31 downto 0)  := x"e5a8bce6";
signal C604: std_logic_vector(31 downto 0)  := x"5274baf4";
signal C704: std_logic_vector(31 downto 0)  := x"26889ba7";
signal C804: std_logic_vector(31 downto 0)  := x"9a226e9d";

signal C110: std_logic_vector(31 downto 0)  := x"b6de10ed";
signal C210: std_logic_vector(31 downto 0)  := x"70f47aae";
signal C310: std_logic_vector(31 downto 0)  := x"0707a3d4";
signal C410: std_logic_vector(31 downto 0)  := x"1c1e8f51";
signal C510: std_logic_vector(31 downto 0)  := x"707a3d45";
signal C610: std_logic_vector(31 downto 0)  := x"aeb28562";
signal C710: std_logic_vector(31 downto 0)  := x"baca1589";
signal C810: std_logic_vector(31 downto 0)  := x"40a46f3e";

signal C114: std_logic_vector(31 downto 0)  := x"01685f3d";
signal C214: std_logic_vector(31 downto 0)  := x"05a17cf4";
signal C314: std_logic_vector(31 downto 0)  := x"bd09caca";
signal C414: std_logic_vector(31 downto 0)  := x"f4272b28";
signal C514: std_logic_vector(31 downto 0)  := x"144ae5cc";
signal C614: std_logic_vector(31 downto 0)  := x"faa7ae2b";
signal C714: std_logic_vector(31 downto 0)  := x"2e48f1c1";
signal C814: std_logic_vector(31 downto 0)  := x"b923c704";

signal C120: std_logic_vector(31 downto 0)  := x"fc20d9d2";
signal C220: std_logic_vector(31 downto 0)  := x"34552e25";
signal C320: std_logic_vector(31 downto 0)  := x"7ad8818f";
signal C420: std_logic_vector(31 downto 0)  := x"8438764a";
signal C520: std_logic_vector(31 downto 0)  := x"bb6de032";
signal C620: std_logic_vector(31 downto 0)  := x"edb780c8";
signal C720: std_logic_vector(31 downto 0)  := x"d9847356";
signal C820: std_logic_vector(31 downto 0)  := x"a2c78434";

signal C124: std_logic_vector(31 downto 0)  := x"e25e72c1";
signal C224: std_logic_vector(31 downto 0)  := x"e623bb72";
signal C324: std_logic_vector(31 downto 0)  := x"5c58a4a4";
signal C424: std_logic_vector(31 downto 0)  := x"1e38e2e7";
signal C524: std_logic_vector(31 downto 0)  := x"78e38b9d";
signal C624: std_logic_vector(31 downto 0)  := x"27586719";
signal C724: std_logic_vector(31 downto 0)  := x"36eda57f";
signal C824: std_logic_vector(31 downto 0)  := x"703aace7";
Begin

Round1 : Round
port map( Q0_in,Q1_in,Q2_in,
			Q0_out_R1,Q1_out_R1,Q2_out_R1,C100,C104,C110,C114,C120,C124);

Round2 : Round
port map( Q0_out_R1,Q1_out_R1,Q2_out_R1,
			Q0_out_R2,Q1_out_R2,Q2_out_R2,C200,C204,C210,C214,C220,C224);
			
Round3 : Round
port map( Q0_out_R2,Q1_out_R2,Q2_out_R2,
			Q0_out_R3,Q1_out_R3,Q2_out_R3,C300,C304,C310,C314,C320,C324);
			         
Round4 : Round
port map( Q0_out_R3,Q1_out_R3,Q2_out_R3,
			Q0_out_R4,Q1_out_R4,Q2_out_R4,C400,C404,C410,C414,C420,C424);
			
Round5 : Round
port map( Q0_out_R4,Q1_out_R4,Q2_out_R4,
			Q0_out_R5,Q1_out_R5,Q2_out_R5,C500,C504,C510,C514,C520,C524);

Round6 : Round
port map( Q0_out_R5,Q1_out_R5,Q2_out_R5,
			Q0_out_R6,Q1_out_R6,Q2_out_R6,C600,C604,C610,C614,C620,C624);
			
Round7 : Round
port map( Q0_out_R6,Q1_out_R6,Q2_out_R6,
			Q0_out_R7,Q1_out_R7,Q2_out_R7,C700,C704,C710,C714,C720,C724);
			
Round8 : Round
port map( Q0_out_R7,Q1_out_R7,Q2_out_R7,
			Q0_out,Q1_out,Q2_out,C800,C804,C810,C814,C820,C824);
			         
	

end internals;
